academic_community/channels/urls.py
"""Urls of the :mod:`~academic_community.channels` app."""

# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from django.urls import include, path

from academic_community.channels import views

app_name = "chats"

urlpatterns = [
    path(
        "groups/", views.ChannelGroupListView.as_view(), name="channelgroups"
    ),
    path(
        "groups/edit/",
        views.ChannelGroupsUpdateView.as_view(),
        name="channelgroup-settings",
    ),
    path(
        "groups/create/",
        views.ChannelGroupCreateView.as_view(),
        name="channelgroup-create",
    ),
    path(
        "groups/<slug>/",
        views.ChannelGroupDetailView.as_view(),
        name="channelgroup-detail",
    ),
    path(
        "groups/<slug>/edit/",
        views.ChannelGroupUpdateView.as_view(),
        name="edit-channelgroup",
    ),
    path("user/", include(views.UserChannelViewSet().urls)),
    path(
        "settings/",
        views.ChatSettingsUpdateView.as_view(),
        name="edit-chatsettings",
    ),
    path("", include(views.CommunityChannelViewSet().urls)),
    path(
        "<int:channel_id>/subscribe/",
        views.ChannelSubscriptionUpdateView.as_view(),
        name="edit-channelsubscription",
    ),
    path(
        "<int:channel_id>/unsubscribe/",
        views.ChannelSubscriptionConfirmDeleteView.as_view(),
        name="delete-channelsubscription",
    ),
    path(
        "<int:channel_id>/uploads/",
        include(views.ChannelMaterialRelationViewSet().urls),
    ),
    path(
        "<int:channel_id>/upload/",
        views.ChannelMaterialUploadFormView.as_view(),
        name="channel-upload",
    ),
    path(
        "<int:channel_id>/keys/",
        views.ChannelEncryptionKeySecretListView.as_view(),
        name="channel-keys",
    ),
    path(
        "<int:channel_id>/subscriber-keys/",
        views.ChannelMasterKeysListView.as_view(),
        name="channel-subscriber-keys",
    ),
    path(
        "<int:channel_id>/subscribers/",
        views.ChannelSubscriptionsView.as_view(),
        name="channel-subscriptions",
    ),
    path(
        "<int:channel_id>/generate-keys/",
        views.CreateMissingKeysView.as_view(),
        name="generate-channel-keys",
    ),
    path(
        "<int:channel_id>/reaction/add/",
        views.CommentReactionView.as_view(),
        name="add-comment-reaction",
    ),
    path(
        "<int:channel_id>/expand-thread/<int:pk>",
        views.ThreadExpandView.as_view(),
        name="toggle-thread-expand",
    ),
]

academic_community/faqs/urls.py
"""Urls of the :mod:`faqs` app."""

# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from django.urls import path

from academic_community.faqs import views

app_name = "faqs"

urlpatterns = [
    path(
        "",
        views.QuestionCategoryListView.as_view(),
        name="questioncategory-list",
    ),
    path(
        "<int:pk>/",
        views.FAQDetailView.as_view(),
        name="faq-detail",
    ),
    path(
        "<int:object_id>/edit/",
        views.FAQUpdateView.as_view(),
        name="edit-faq",
    ),
    path(
        "<slug>/",
        views.QuestionCategoryDetailView.as_view(),
        name="questioncategory-detail",
    ),
    path(
        "<slug>/edit/",
        views.QuestionCategoryUpdateView.as_view(),
        name="edit-questioncategory",
    ),
]

academic_community/members/urls.py
"""Urls of the :mod:`members` app."""

# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from django.conf import settings
from django.urls import path, re_path
from django.views.decorators.cache import never_cache

from academic_community.members import views

app_name = "members"

urlpatterns = [
    re_path(
        r"member/(?P<pk>\d+)/?$",
        views.RedirectMemberView.as_view(),
        name="members",
    ),
    path("profile/", views.ProfileView.as_view(), name="profile"),
    path(
        "profile/edit/", views.EditProfileView.as_view(), name="edit-profile"
    ),
    path(
        "profile/edit/emails/",
        views.ProfileEmailUpdateView.as_view(),
        name="edit-profile-emails",
    ),
    path(
        "verify/",
        views.SendVerificationEmailView.as_view(),
        name="send-verification-mail",
    ),
    path(
        "verify/<uuid:pk>/",
        # this view should never be cached as it can also be modified by
        # anonymous users
        never_cache(views.VerifyEmailView.as_view()),
        name="verify-email",
    ),
]


if getattr(settings, "COMMUNITY_MEMBER_REGISTRATION", True):
    urlpatterns.extend(
        [
            path(
                "profile/become-a-member/",
                views.SelfRequestMemberStatusView.as_view(),
                name="self-become-member",
            ),
            # we need to add these views here to make sure, communitymembers
            # can always approve other members. Otherwise they might be blocked
            # through CMS permissions
            re_path(
                r"member/(?P<pk>\d+)/approve/?$",
                views.GrantMemberStatusView.as_view(),
                name="approve-member",
            ),
        ]
    )

academic_community/notifications/urls.py
"""Urls of the :mod:`notifications` app."""

# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from django.urls import path
from django.views.decorators.csrf import csrf_exempt

from academic_community.notifications import views

app_name = "notifications"

urlpatterns = [
    path(
        "",
        views.NotificationListView.as_view(),
        name="inbox",
    ),
    path(
        "system/",
        views.SystemNotificationListView.as_view(),
        name="inbox-system",
    ),
    path(
        "user/",
        views.UserNotificationListView.as_view(),
        name="inbox-user",
    ),
    path(
        "chats/",
        views.ChatNotificationListView.as_view(),
        name="inbox-chat",
    ),
    path(
        "archive/",
        views.ArchivedNotificationListView.as_view(),
        name="inbox-archived",
    ),
    path(
        "new/",
        views.CreateOutgoingNotificationView.as_view(),
        name="create-notification",
    ),
    path(
        "settings/",
        views.NotificationSettingsUpdateView.as_view(),
        name="settings",
    ),
    path(
        "settings/system/",
        views.SystemNotificationSettingsUpdateView.as_view(),
        name="settings-system",
    ),
    path(
        "settings/user/",
        views.UserNotificationSettingsUpdateView.as_view(),
        name="settings-user",
    ),
    path(
        "settings/chat/",
        views.ChatNotificationSettingsUpdateView.as_view(),
        name="settings-channels",
    ),
    path(
        "settings/chat/<int:channel_id>/",
        views.ChannelNotificationSettingsUpdateView.as_view(),
        name="settings-channel",
    ),
    path(
        "settings/chat/<int:channel_id>/reset/",
        views.ChannelNotificationSettingsDeleteView.as_view(),
        name="settings-channel-delete",
    ),
    path(
        "webpush/<uuid:uuid>/<int:notification_id>/<token>/",
        csrf_exempt(views.NotificationSubscriptionActionView.as_view()),
        name="subscription-push",
    ),
    path(
        "<int:pk>/",
        views.NotificationDetailView.as_view(),
        name="notification-detail",
    ),
    path(
        "<int:pk>/send/",
        views.SendNotificationView.as_view(),
        name="send-notification",
    ),
]

academic_community/rest/urls.py
# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from django.urls import include, path
from rest_framework import routers

from academic_community.rest import views

app_name = "rest"

router = routers.DefaultRouter()
router.register("institutions", views.InstitutionViewSet)
router.register("departments", views.DepartmentViewSet)
router.register("notifications", views.NotificationViewSet)
# router.register("events/registrations/", views.RegistrationViewSet)
router.register("events/programme/sessions", views.SessionViewSet)
router.register("events/programme/submissions", views.ContibutionViewSet)
router.register("events/programme/slots", views.SlotViewSet)


event_router = routers.DefaultRouter()
event_router.root_view_name = "event-api-root"
event_router.register("registrations", views.RegistrationViewSet)


urlpatterns = [
    path("users/query/", views.UserListView.as_view(), name="query-userlinks"),
    path(
        "comments/query/",
        views.CommentListView.as_view(),
        name="query-commentlinks",
    ),
    path(
        "comments/<pk>/report/",
        views.CommentReadReportUpdateView.as_view(),
        name="edit-commentreadreport",
    ),
    path(
        "mentions/query/",
        views.MentionedObjectsListView.as_view(),
        name="query-mentionlinks",
    ),
    path(
        "notifications/subscribe/",
        views.NotificationSubscriptionUpdateView.as_view(),
        name="edit-notificationsubscription",
    ),
    path(
        "notifications/unread/",
        views.UnreadNotificationCountView.as_view(),
        name="notification-count",
    ),
    path(
        "notifications/preview/",
        views.PreviewNotificationsApiView.as_view(),
        name="preview-notifications",
    ),
    path("event/<event_slug>/", include(event_router.urls)),
    path("", include(router.urls)),
]

academic_community/search/urls.py
"""Urls of the :mod:`topics` app."""

# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from django.urls import path

from academic_community.search import views

app_name = "search"

urlpatterns = [
    path("", views.SearchView.as_view(), name="search"),
]

academic_community/urls.py
# Copyright (C) 2020-2021 Helmholtz-Zentrum Geesthacht
# Copyright (C) 2021 Helmholtz-Zentrum Hereon
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from cms.sitemaps import CMSSitemap
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.contrib.sitemaps.views import sitemap
from django.urls import include, path
from django.views.i18n import JavaScriptCatalog

from academic_community import views

admin.autodiscover()

urlpatterns = [
    path("sitemap.xml", sitemap, {"sitemaps": {"cmspages": CMSSitemap}}),
    path("e2ee/", views.E2EEStatusView.as_view(), name="e2ee-status"),
    path(
        "e2ee/delete/<uuid:uuid>/",
        views.MasterKeySecretDeleteView.as_view(),
        name="masterkeysecret-delete",
    ),
    path("e2ee/rest/", include("django_e2ee.urls")),
    path("notifications/", include("academic_community.notifications.urls")),
    path("rest/", include("academic_community.rest.urls")),
    path("channels/", include("academic_community.channels.urls")),
    path("search/", include("academic_community.search.urls")),
    path("history/", include("academic_community.history.urls")),
    path("contact/", include("academic_community.contact.urls")),
    path("faqs/", include("academic_community.faqs.urls")),
    path("captcha/", include("captcha.urls")),
    path("mailinglists/", include("academic_community.mailinglists.urls")),
    path("uploads/", include("academic_community.uploaded_material.urls")),
    path("select2/", include("django_select2.urls")),
    # include the Django Admins Javascript Catalog (necessary for the
    # forms.FilteredSelectMultiple widget)
    path(
        "jsi18n/",
        JavaScriptCatalog.as_view(packages=["academic_community"]),
        name="jsi18n",
    ),
    path(
        "manifest.webmanifest",
        views.ManifestView.as_view(),
        name="webmanifest",
    ),
    path(
        "serviceworker.js",
        views.ServiceWorkerView.as_view(),
        name="serviceworker",
    ),
    path("accounts/", include("academic_community.members.urls")),
    path("", include("cms.urls")),
]

# This is only needed when using runserver.
if settings.DEBUG:
    urlpatterns += static(
        settings.MEDIA_URL, document_root=settings.MEDIA_ROOT
    )
    urlpatterns += static(
        settings.STATIC_URL, document_root=settings.STATIC_ROOT
    )

testproject/urls.py
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: CC0-1.0

"""django-academic-community URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.contrib import admin
from django.urls import include, path  # noqa: F401

urlpatterns = [
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    path(settings.ADMIN_LOCATION, admin.site.urls),
    path("accounts/", include("django.contrib.auth.urls")),
    path("", include("academic_community.urls")),
]

academic_community/channels/models/cms.py
# SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH
#
# SPDX-License-Identifier: EUPL-1.2

from __future__ import annotations

from typing import Optional, Type

from cms.models import CMSPlugin
from django.db import models
from django.utils.translation import gettext as _
from djangocms_frontend.fields import AttributesField

from academic_community.channels.models.channel_type import BaseChannelType
from academic_community.channels.models.core import Channel, ChannelKeyword
from academic_community.models.cms import AbstractPaginationPluginModelMixin


class AbstractChannelListPluginModel(  # type: ignore[django-manager-missing]
    AbstractPaginationPluginModelMixin, CMSPlugin
):
    """An abstract base model to display a member list."""

    class Meta:
        abstract = True

    check_permissions = models.BooleanField(  # type: ignore[var-annotated]
        default=True,
        help_text=(
            "Only display the members that the website visitor can view the "
            "profile of."
        ),
    )

    channel_type = models.CharField(  # type: ignore[var-annotated]
        null=True,
        blank=True,
        help_text="Only display channels of a specific type.",
        max_length=20,
        choices=[(None, "All Channels")]
        + sorted(
            (
                BaseChannelType.registry.get_model_name(model),
                model.get_verbose_name_plural(),
            )
            for model in BaseChannelType.registry.registered_models
        ),
    )

    keywords = models.ManyToManyField(  # type: ignore[var-annotated]
        ChannelKeyword,
        blank=True,
        help_text="Select keywords that you want to filter for.",
    )

    all_keywords_required = models.BooleanField(  # type: ignore[var-annotated]
        default=False,
        help_text="Show only material that has all of the mentioned keywords.",
    )

    attributes = AttributesField(
        verbose_name=_("Attributes for the surrounding container"),
        blank=True,
    )

    @property
    def channel_type_model(self) -> Optional[Type[BaseChannelType]]:
        """Get the model for the channel type (or None)."""
        if self.channel_type:
            return BaseChannelType.registry.get_model(self.channel_type)
        return None

    def copy_relations(self, oldinstance):
        self.keywords.clear()
        self.keywords.add(*oldinstance.keywords.all())


class ChannelListPluginModel(AbstractChannelListPluginModel):  # type: ignore[django-manager-missing]
    """A plugin model to display community members."""

    channels = models.ManyToManyField(  # type: ignore[var-annotated]
        Channel, blank=True, help_text="The channels to display."
    )

    show_all = models.BooleanField(  # type: ignore[var-annotated]
        default=False,
        help_text="Show all channels, no matter what you selected above.",
    )

    def copy_relations(self, oldinstance):
        self.channels.clear()
        self.channels.add(*oldinstance.channels.all())

academic_community/templates/academic_community/dropdown_divider.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

<hr class="dropdown-divider">

academic_community/templates/academic_community/dropdown_header.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

<h6 class="dropdown-header">{{ instance.text }}</h6>

academic_community/templates/academic_community/is_anonymous_plugin.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% load cms_tags %}

{% if not request.user.is_authenticated %}
    {% for plugin in instance.child_plugin_instances %}
        {% with forloop as parentloop %}{% render_plugin plugin %}{% endwith %}
    {% endfor %}
{% endif %}

academic_community/templates/academic_community/is_authenticated_plugin.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% load cms_tags %}

{% if request.user.is_authenticated %}
    {% for plugin in instance.child_plugin_instances %}
        {% with forloop as parentloop %}{% render_plugin plugin %}{% endwith %}
    {% endfor %}
{% endif %}

academic_community/templates/academic_community/profile_button.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% load community_utils%}
{% load notification_helpers %}

{% if user.is_authenticated %}
  <div>
  {% profile user profile_class=instance.classes url="#" profile_id="profile-button" button_attrs='data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false"' %}
    {% block button_content %}
      {% with unread_notifications=user.unread_notifications %}
        <span class="notification-badge btn-profile-badge position-absolute translate-middle p-2 bg-danger border border-light rounded-circle top-10 start-90 {% if not unread_notifications %}invisible{% endif %}">
          <span class="visually-hidden">unread notifications</span>
        </span>
      {% endwith %}
    {% endblock button_content %}
    {% endprofile %}
    {% comment %} position-absolute is necessary because bootstrap adds position: static for "navbar dropdown-menu"  {% endcomment %}
    <div class="dropdown-menu dropdown-menu-end position-absolute me-4" aria-labelledby="profile-button">
      {% block dropdown %}
        {% block username %}
          <div class="dropdown-item-text">
            Logged in as <span class="fw-bold">{{ user.get_username }}</span>
          </div>
        {% endblock username %}
        {% block availability %}
          <a class="dropdown-item" href="{% url 'chats:edit-chatsettings' %}?next={% url_for_next %}&tab=availabilityTab">
            Availability: <span class="availability-text" data-availability-id="{{ user.id }}"></span>
          </a>
        {% endblock availability %}
        {% block notifications %}
          {% notifications_button button_class="dropdown-item" button_text="Notifications" %}
        {% endblock notifications %}
        <div class="dropdown-divider"></div>
        <div><h6 class="dropdown-header">My Settings</h6></div>
        {% block profile_settings %}
          {% if user.communitymember %}
            <a class="dropdown-item" href="{% url 'members:profile' %}">My Profile</a>
            <a class="dropdown-item" href="{% url 'members:edit-profile-emails' %}">My Emails</a>
            {% if not user.communitymember.is_member %}
            {% url 'members:self-become-member' as become_member_url %}
            {% if become_member_url %}
              <a class="dropdown-item fw-bold" href="{{ become_member_url }}">Become a community member</a>
            {% endif  %}
            {% endif %}
          {% endif %}
        {% endblock profile_settings %}
        {% block other_settings %}
          <a class="dropdown-item" href="{% url 'password_change' %}">Change password</a>
          <a class="dropdown-item" href="{% url 'e2ee-status' %}">End-to-end message encryption</a>
          <a class="dropdown-item" href="{% url 'chats:edit-chatsettings' %}">My Chat settings</a>
          <a class="dropdown-item" href="{% url 'notifications:settings-system' %}?next={% url_for_next %}">Notification settings</a>
        {% endblock other_settings %}
        <div class="dropdown-divider"></div>
        <div><h6 class="dropdown-header">My Content</h6></div>
        {% block user_content %}
          <a class="dropdown-item" href="{% url 'usermaterial-list' %}">My Uploads</a>
          <a class="dropdown-item" href="{% url 'chats:userchannel-list' %}">My Created channels</a>
        {% endblock user_content %}
        <div class="dropdown-divider"></div>
        {% block footer %}
          <a class="dropdown-item link-primary" role="button" href="{% url 'logout' %}?next={% url_for_next %}">Logout</a>
        {% endblock footer %}
      {% endblock dropdown %}
    </div>
  </div>
{% endif %}

academic_community/templates/academic_community/search_bar.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% load sekizai_tags %}

<button class="btn btn-search nav-icon-button me-md-3" type="button" id="search-toggle"></button>
<div class="d-flex" id="search-wrapper">
  <form class="row row-cols-auto align-items-center" id="search-form" action="{% url 'search:search' %}" method="get">
    <input name="q" class="form-control" type="search" placeholder="Search" aria-label="Search" id="search-text">
    <button class="btn nav-icon-button btn-search" type="submit"></button>
    <button class="btn d-none d-lg-block nav-icon-button btn-cancel" id="btn-search-cancel"></button>
  </form>
</div>

{% addtoblock "js" %}
  <script>
    document.getElementById("search-toggle").addEventListener(
      "click", function(e) {
        e.preventDefault();
        $("#search-wrapper").toggleClass("toggled");
        $("#search-toggle").toggleClass("toggled");
        $("#search-text").focus();
     }
    );
    document.getElementById("btn-search-cancel").addEventListener(
      "click", function(e) {
        e.preventDefault();
        $("#search-wrapper").toggleClass("toggled");
        $("#search-toggle").toggleClass("toggled");
      }
    );
    document.getElementById("search-text").addEventListener(
      "keydown", function(e) {
        if (e.key === "Escape") {
          $("#search-toggle").click();
        }
      }
    );
  </script>
{% endaddtoblock %}

academic_community/templates/academic_community/splitdurationwidget.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% spaceless %}
<div class="form-row">
  {% for widget in widget.subwidgets %}
    <div class="col-auto">
      {% include widget.template_name %}
      <small class="form-text text-muted">
        {{ widget.attrs.help_text }}
      </small>
    </div>
  {% endfor %}
</div>
{% endspaceless %}

academic_community/templates/academic_community/user_group_based_content.html
{% comment %}
SPDX-FileCopyrightText: 2020-2023 Helmholtz-Zentrum hereon GmbH

SPDX-License-Identifier: EUPL-1.2
{% endcomment %}

{% load cms_tags %}

{% if render_content %}
    {% for plugin in instance.child_plugin_instances %}
        {% with forloop as parentloop %}{% render_plugin plugin %}{% endwith %}
    {% endfor %}
{% endif %}